// Autores: Grupo Clone Wars
// URL: https://groups.google.com/d/topic/asrob-uc3m-impresoras-3d/WwnpXNy7HnQ/discussion
//
// Licencia: CC BY-NC 3.0
//  http://creativecommons.org/licenses/by-nc/3.0/
//
// Si realizan modificaciones, agradeceríamos que se comunicase en el grupo.
// Gracias.
// 
// Diseño de piezas para la adaptación de la
// P3Steel (http://www.thingiverse.com/thing:157303)diseñada por iRobri
// para usarla con husillos de 10mm de diámetro. 
// 
// Se trata de modificar las piezas superior e inferior del eje Z para separar
// la varilla lisa del husillo, de forma que quede espacio para la tuerca
// y los rodamientos en las piezas del eje X.
//
// Las modificaciones para las piezas del eje X se encuentran en otro fichero.
//
// Uso: La función 'piezas_no_imprimibles()' y las piezas que usa son sólo
// para comprobar el encaje de las piezas.
//
// Las dos piezas a imprimir son: 
//  - adaptador_inf()
//  - adaptador_sup()
//
// Usar la función 'mirror()' para obtener las piezas del otro
// lado, ya que tienen 'mano'.
//
//***********************************************************//
//********* Comentar esto antes de exportar el stl **********//
translate([0,0,-3])
	piezas_no_imprimibles();
//***********************************************************//
//***********************************************************//

//mirror(){
	adaptador_inf();
//translate([0,0,-317])   
	adaptador_sup();
//}

//**********************************************************//
//**********************************************************//


$fn=100;
distancia_varillas=22;
altura=321;

module motor_nema17(){
	translate([0,0,-39.5])
		scale([1,1,0.86])
			import("MotorNema17.stl");
}

module acople_motor(){
	translate([0,0,10])
		difference(){
			#cylinder(r=25/2,h=30);
			union(){
				translate([0,0,-1])
					cylinder(r=5/2,h=11);
				translate([0,0,9])
					cylinder(r=10/2,h=22);
			}
		}
}

module soporte_inf_acero(){
	translate([-30,-20.7,0])
	linear_extrude(height=3)
		import("Soporte_Motor_Z.dxf");
}
module soporte_sup_acero(){
	translate([-58.2,63.5,altura-1])
		rotate([0,0,180])
			rotate([0,180,0])
				linear_extrude(height=3)
					import("Z_Superior.dxf");
}
module marco(){
	translate([35,32.5,-48])
		rotate([0,0,-90])
			translate([0,-400,368])
				rotate([0,90,0])
					linear_extrude(height=3)
						import("marco.dxf");
}
module adaptador_sup(){
	difference(){
		union(){
			translate([-58.2,63.5,altura])
				rotate([0,0,180])
					rotate([0,180,0]){
						difference(){
							union(){
								linear_extrude(height=4)
									import("Adaptador_Superior.dxf");
//								translate([75,63.5,3])
//									#cylinder(r=4,h=4);
							}
							translate([52.1,32.7,-2])
								cylinder(r=3,h=5);
							translate([13.25,10.2,-2])
								cylinder(r=3,h=5);
						}
					}
		}
		varilla_lisa_M8();
	}
}
module x_end_idler(){
	rotate([0,0,-90])
		translate([-6,22,160])
			rotate([180,0,0])
				import("x-end-idler.stl");
}

module varilla_roscada_M10(){
	color("blue")
		translate([0,0,30])
			cylinder(r=5,h=280);
}

module varilla_lisa_M8(){
	color("lightblue")
		translate([distancia_varillas,0,0])
		cylinder(r=4,h=330);
}

module piezas_no_imprimibles(){
	varilla_roscada_M10();
	//Se sube para no pegar en el tornillo y el hueco
	translate([0,0,8])		
		varilla_lisa_M8();
	color("green"){
		soporte_sup_acero();
		x_end_idler();
		soporte_inf_acero();
	}
	color("orange"){
		taladros_motor();
		marco();
	}
	color("black")
		motor_nema17();
	color("gray")
		acople_motor();
}

module taladros_motor(radio=1.5,altura=25){
	rotate([0,0,0])
		translate([15.5,15.5,0])
			cylinder(r=radio,h=altura,center=true);
	rotate([0,0,90])
		translate([15.5,15.5,0])
			cylinder(r=radio,h=altura,center=true);
	rotate([0,0,180])
		translate([15.5,15.5,0])
			cylinder(r=radio,h=altura,center=true);
	rotate([0,0,270])
		translate([15.5,15.5,0])
			cylinder(r=radio,h=altura,center=true);
}

module extension_inferior(){
	translate([-20,-20.8,0])
		union(){
			cube([50,40,4]);
			translate([35.5,9,2])
				cube([14.5,24,8]);
		}
}

module extension_inferior2(){
	translate([-20,-20.8,0])
		difference(){
			cube([50,40,10]);
			translate([-5,-5,4])
				cube([60,50,10]);
		}
}

module huecos_ext_inferior(){

	//tornillo inferior
	translate([21.5,1,-1])
		cube([10,7,5]);
	taladros_motor();
	//hueco cabeza tornillo
	translate([0,0,5+2])
		taladros_motor(3,10);
	//hueco eje motor
	translate([0,0,-1])
		cylinder(r=11.1,h=4+2);
	//hueco varilla lisa
	translate([0,0,5])		
		varilla_lisa_M8();
}

module adaptador_inf(){
	difference(){
		extension_inferior();
		huecos_ext_inferior();
	}
}